export enum IPFlag {
	FLAGGED = 0,
	USER_IP,
	RESTRICT_UPLOAD,
	RESTRICT_REGISTRATION,
	REJECT
}

export interface IPAddressQuery {
	ip?: string;
	flags?: number;
	user?: string;
	listId?: number;
	includeUsers?: boolean;
}

export interface IPAddressListEntry {
	id: number;
	ip_address: string;
	flags: number;
	created_at: Date;
	updated_at: Date;
	list: {
		id: number;
		name: string;
	} | null;
	user_count: number;
	users?: {
		uuid: string;
		display_name: string;
	}[];
}
